## mingw-w64-opencolorio-2.4.2-3.src.tar.zst

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.


###############################################################################
# CMake definition.

cmake_minimum_required(VERSION 3.14)

set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/share/cmake/utils
    ${CMAKE_CURRENT_SOURCE_DIR}/share/cmake/macros
    ${CMAKE_CURRENT_SOURCE_DIR}/share/cmake/modules
    ${CMAKE_CURRENT_SOURCE_DIR}/share/cmake/modules/install
)

set(CMAKE_WARN_DEPRECATED ON)


if(APPLE AND NOT DEFINED CMAKE_OSX_DEPLOYMENT_TARGET)
    # The value of this variable should be set prior to the first project() command invocation
    # because it may influence configuration of the toolchain and flags.
    set(CMAKE_OSX_DEPLOYMENT_TARGET "10.13" CACHE STRING "Minimum OS X deployment version")
endif()


###############################################################################
# Project definition.

project(OpenColorIO 
    VERSION 2.4.2
    DESCRIPTION "OpenColorIO (OCIO) is a complete color management solution"
    HOMEPAGE_URL https://github.com/AcademySoftwareFoundation/OpenColorIO
    LANGUAGES CXX C)

# "dev", "beta1", rc1", etc or "" for an official release.
set(OpenColorIO_VERSION_RELEASE_TYPE "")


###############################################################################
# ctest

# To correctly generate the DartConfiguration.tcl, include the CTest CMake file.
# By doing so 'ctest -F memcheck' works.
include (CTest)

enable_testing()


###############################################################################
# Provides install directory variables as defined by the GNU Coding Standards.
include(GNUInstallDirs)


###############################################################################
# Forbid in-source build.

if(${PROJECT_SOURCE_DIR} STREQUAL ${PROJECT_BINARY_DIR})
    message(FATAL_ERROR 
            "In-source build not allowed. Please make a new sub-directory and run cmake from there.")
endif()


###############################################################################
# Global CMake options.

# Do not output install messages.
if(NOT DEFINED CMAKE_INSTALL_MESSAGE)
    set(CMAKE_INSTALL_MESSAGE "NEVER")
endif()

# Change the path max size to avoid problem on Windows.
if(NOT DEFINED CMAKE_OBJECT_PATH_MAX)
    set(CMAKE_OBJECT_PATH_MAX 300)
endif()


###############################################################################
# Define compilation mode i.e. debug or release

if(NOT DEFINED CMAKE_BUILD_TYPE OR CMAKE_BUILD_TYPE STREQUAL "")
    message(STATUS "Setting build type to 'Release' as none was specified.")
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build." FORCE)
endif()

# List all the valid build types.

if(NOT DEFINED CMAKE_CONFIGURATION_TYPES)
    set(CMAKE_CONFIGURATION_TYPES "Debug;Release;MinSizeRel;RelWithDebInfo" CACHE STRING "" FORCE)
    mark_as_advanced(CMAKE_CONFIGURATION_TYPES)
endif()

set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")

# Is that a valid build type?

set(_build_type_valid_ false)
foreach (_build_type_ ${CMAKE_CONFIGURATION_TYPES})
    string(TOLOWER ${_build_type_} _lowercase_build_type_)
    string(TOLOWER ${CMAKE_BUILD_TYPE} _lowercase_cmake_build_type_)

    if (_lowercase_cmake_build_type_ STREQUAL _lowercase_build_type_)
        # Build type is supported.
        set(_build_type_valid_ true)
        break()
    endif()
endforeach()
unset(_lowercase_build_type_)
unset(_lowercase_cmake_build_type_)

if (NOT _build_type_valid_)
    string(REPLACE ";" ", " _CMAKE_CONFIGURATION_TYPES_STR "${CMAKE_CONFIGURATION_TYPES}")
    message(FATAL_ERROR 
            "CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE} is unsupported. Supported values are: ${_CMAKE_CONFIGURATION_TYPES_STR}.")
endif()
unset(_build_type_valid_)

# Is that in debug mode?

set(_BUILD_TYPE_DEBUG OFF)
if(CMAKE_BUILD_TYPE MATCHES "[Dd][Ee][Bb][Uu][Gg]")
    set(_BUILD_TYPE_DEBUG ON)
endif()

set(BUILD_TYPE_DEBUG ${_BUILD_TYPE_DEBUG})


###############################################################################
# C++ version configuration

include(Compilers)
include(CppVersion)


###############################################################################
# Components to build

option(BUILD_SHARED_LIBS "Set to OFF to build static libraries" ON)
option(OCIO_BUILD_APPS "Set to OFF to disable command-line apps" ON)
option(OCIO_BUILD_OPENFX "Specify whether to build OpenFX plugins" OFF)
option(OCIO_BUILD_NUKE "Specify whether to build nuke plugins" OFF)
option(OCIO_BUILD_TESTS "Specify whether to build unittests" ON)
option(OCIO_BUILD_GPU_TESTS "Specify whether to build gpu unittests" ON)
option(OCIO_USE_HEADLESS "Specify whether the GPU rendering is headless" OFF)

option(OCIO_BUILD_FROZEN_DOCS "Specify whether to build frozen documentation, necessary when modifying the OCIO public API" OFF)
option(OCIO_BUILD_DOCS "Specify whether to build documentation" ${OCIO_BUILD_FROZEN_DOCS})

option(OCIO_BUILD_PYTHON "Specify whether to build python bindings" ON)
set (OCIO_PYTHON_VERSION "" CACHE STRING
     "Preferred Python version (if any) in case multiple are available")

option(OCIO_BUILD_JAVA "Specify whether to build java bindings" OFF)

if (WIN32)
    option(OCIO_USE_WINDOWS_UNICODE "Compile with Windows Unicode support" ON)
endif()

###############################################################################
# Other preferences

option(OCIO_VERBOSE "Display more information when searching or installing dependencies" OFF)
option(OCIO_USE_SOVERSION "Enable versioning in OCIO shared library name" ON)

###############################################################################
# Warnings / debugging settings

option(OCIO_WARNING_AS_ERROR "Set build error level for CI testing" OFF)

if (NOT WIN32)
    option(OCIO_ENABLE_SANITIZER "Specify whether to enable compiler sanitizers (address)" OFF)
endif()


###############################################################################
# Optimization / internal linking preferences
option(OCIO_USE_SIMD "Specify whether to enable SIMD CPU performance optimizations" ON)
option(OCIO_USE_OIIO_FOR_APPS "Request OIIO to build apps (ociolutimage, ocioconvert and ociodisplay), the default uses OpenEXR." OFF)


if (NOT APPLE)
    if("${CMAKE_GENERATOR_PLATFORM}" MATCHES "(ARM64|arm64)" OR CMAKE_SYSTEM_PROCESSOR STREQUAL "ARM64")
        set(OCIO_ARCH_X86 0)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX OFF)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C OFF)
    elseif ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(AMD64|IA64|EM64T|x86_64|X86|i386|i686)")
        # Intel-based architecture (not APPLE)
        if ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(X86|i386|i686)")
            set(OCIO_ARCH_X86_32 1)
        endif()
        set(OCIO_ARCH_X86 1)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX ON)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C ON)
    else()
        set(OCIO_ARCH_X86 0)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE OFF)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX OFF)
        set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C OFF)
    endif()
elseif (APPLE)
    # Multiple possible scenarios:
    # A. Building on an Apple arm64 architecture for the native architecture (arm64).
    # B. Building on an Apple arm64 architecture for x86_64.
    # C. Building on an Apple arm64 architecture for universal binaries (x86_64 + arm64).
    #
    # D. Building on an Apple Intel architecture for the native architecture (x86_64).
    # E. Building on an Apple Intel architecture for arm64.
    # F. Building on an Apple Intel architecture for universal binaries (x86_64 + arm64).

    # Check if we are NOT cross-compiling to another Apple architecture.
    if (NOT DEFINED CMAKE_OSX_ARCHITECTURES OR CMAKE_OSX_ARCHITECTURES STREQUAL "")
        # Building for the native architectures.
        if ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64")
            # Apple Intel-based computer or Rosetta. (covers case D)

            set(OCIO_ARCH_X86 1)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
            # The AVX and F16C will be compiled, but it won't used at runtime by Rosetta.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX ON)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C ON)
        elseif ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "arm64")
            # Apple arm64. (covers case A)

            set(OCIO_ARCH_X86 0)
            # OCIO translates the SSE instructions into ARM Neon with the library SSE2NEON.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
            # OCIO does not translate AVX to ARM Neon.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX OFF)
            # Turn F16C off since they are x86_64 instructions.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C OFF)
        endif()
    else()
        # Cross-compiling to another Apple architecture (x86_64, arm64, or both (universal))
        if ("${CMAKE_OSX_ARCHITECTURES}" STREQUAL "x86_64")
            # Compiling for x86_64 regardless of native architecture.
            # Covers case B assuming CMAKE_SYSTEM_PROCESSOR is arm64.
            # Covers case D if CMAKE_OSX_ARCHITECTURES is set to x86_64 on x86_64 architecture.

            set(OCIO_ARCH_X86 1)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
            # The AVX and F16C will be compiled, but they won't used at runtime by Rosetta.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX ON)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C ON)
        elseif ("${CMAKE_OSX_ARCHITECTURES}" STREQUAL "arm64")
            # Compiling for arm64 regardless of native architecture.
            # Covers case E assuming CMAKE_SYSTEM_PROCESSOR is x86_64.
            # Covers case A if CMAKE_OSX_ARCHITECTURES is set arm64 on arm64 architecture.

            set(OCIO_ARCH_X86 0)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX OFF)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C OFF)
        elseif ("${CMAKE_OSX_ARCHITECTURES}" MATCHES "(arm64;x86_64|x86_64;arm64)")
            # Universal build (covers case C and F).

            set(OCIO_ARCH_X86 1)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE ON)
            # The AVX and F16C will be compiled, but they won't used at runtime by Rosetta.
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX ON)
            set(OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C ON)
        endif()
    endif()
endif()

option(OCIO_USE_SSE2 "Specify whether to enable SSE2 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE})
option(OCIO_USE_SSE3 "Specify whether to enable SSE3 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE})
option(OCIO_USE_SSSE3 "Specify whether to enable SSSE3 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE})
option(OCIO_USE_SSE4 "Specify whether to enable SSE4 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE})
option(OCIO_USE_SSE42 "Specify whether to enable SSE4.2 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_SSE})
option(OCIO_USE_AVX "Specify whether to enable AVX CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX})
option(OCIO_USE_AVX2 "Specify whether to enable AVX2 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX})
option(OCIO_USE_AVX512 "Specify whether to enable AVX512 CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_AVX})
option(OCIO_USE_F16C  "Specify whether to enable F16C CPU performance optimizations" ${OCIO_BUILD_ENABLE_OPTIMIZATIONS_F16C})

if (APPLE OR WIN32)
   # TODO: Revisit whether that option is necessary.
   option(OCIO_USE_SSE2NEON "Specify whether to enable SSE CPU performance optimizations using SSE2NEON for Apple ARM architecture" ON)

=== vendor/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.


if(OCIO_BUILD_NUKE)
    add_subdirectory(nuke)
endif()

if(OCIO_BUILD_OPENFX)
    add_subdirectory(openfx)
endif()

=== src/apps/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.

if(OCIO_BUILD_APPS)
	add_subdirectory(ocioarchive)
	add_subdirectory(ociobakelut)
	add_subdirectory(ociocheck)
	add_subdirectory(ociochecklut)
	add_subdirectory(ociocpuinfo)
	add_subdirectory(ociomakeclf)
	add_subdirectory(ocioperf)
	add_subdirectory(ociowrite)

	if(TARGET OpenColorIO::ImageIOBackend)
		add_subdirectory(ociolutimage)
		add_subdirectory(ocioconvert)
		add_subdirectory(ociodisplay)
	else()
		message(WARNING "Could NOT find OpenImageIO or OpenEXR. Skipping build for ociolutimage, ocioconvert and ociodisplay.")
	endif()
else()
	message(WARNING "Skipping build of all apps.")
endif()

=== tests/python/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.

set(BUILD_TYPE "")
if (MSVC_IDE)
    # Note: By default Microsoft Visual Studio editor happens the build type to the build directory.
    set(BUILD_TYPE ${CMAKE_BUILD_TYPE})
endif()

add_test(test_python ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/OpenColorIOTestSuite.py ${PROJECT_BINARY_DIR} ${BUILD_TYPE})

=== tests/testutils/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.

set(SOURCES
    UnitTest.cpp
)

add_library(testutils STATIC ${SOURCES})

set_target_properties(testutils PROPERTIES
    COMPILE_OPTIONS "${PLATFORM_COMPILE_OPTIONS}"
    LINK_OPTIONS "${PLATFORM_LINK_OPTIONS}"
)

target_include_directories(testutils
    PUBLIC
        ${CMAKE_CURRENT_SOURCE_DIR}/..
)

target_link_libraries(testutils
    PRIVATE
        apputils
        utils::strings
)

=== src/apps/ociocpuinfo/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright Contributors to the OpenColorIO Project.

set(SOURCES
    main.cpp
    ${PROJECT_SOURCE_DIR}/src/OpenColorIO/CPUInfo.cpp
)

add_executable(ociocpuinfo ${SOURCES})

set_target_properties(ociocpuinfo PROPERTIES
    COMPILE_OPTIONS "${PLATFORM_COMPILE_OPTIONS}"
    LINK_OPTIONS "${PLATFORM_LINK_OPTIONS}"
)

target_include_directories(ociocpuinfo
    PRIVATE
        "$<TARGET_PROPERTY:OpenColorIO,INCLUDE_DIRECTORIES>"
        "${PROJECT_BINARY_DIR}/generated_include"
)

include(StripUtils)
ocio_strip_binary(ociocpuinfo)

install(TARGETS ociocpuinfo
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=opencolorio
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
conflicts=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
replaces=("${MINGW_PACKAGE_PREFIX}-${_realname}-git")
pkgver=2.4.2
pkgrel=3
pkgdesc="A color management framework for visual effects and animation (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://opencolorio.org/"
msys2_repository_url='https://github.com/AcademySoftwareFoundation/OpenColorIO'
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-freeglut"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-imath"
         "${MINGW_PACKAGE_PREFIX}-lcms2"
         "${MINGW_PACKAGE_PREFIX}-minizip-ng"
         "${MINGW_PACKAGE_PREFIX}-openexr"
         "${MINGW_PACKAGE_PREFIX}-yaml-cpp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-pybind11"
             "${MINGW_PACKAGE_PREFIX}-pystring"
             "${MINGW_PACKAGE_PREFIX}-python"
             $( [[ "${CARCH}" != "aarch64" ]] \
                || echo "${MINGW_PACKAGE_PREFIX}-sse2neon" )
             "${MINGW_PACKAGE_PREFIX}-zlib")
checkdepends=("${MINGW_PACKAGE_PREFIX}-openshadinglanguage")
optdepends=("${MINGW_PACKAGE_PREFIX}-python: Python bindings")
source=(https://github.com/AcademySoftwareFoundation/OpenColorIO/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz
        0003-fix-python-sitearch.patch
        0005-fix-ifstream-arg.patch
        0006-fix-neon-build.patch)
sha256sums=('2d8f2c47c40476d6e8cea9d878f6601d04f6d5642b47018eaafa9e9f833f3690'
            '4bb650747906aab5b71579d05674ee59a811d6370a6dcda93b5880abb094be70'
            'd2c3b20715ade9cf7599967e8cdd8688ad71e4956fa1825c9025ff862e8bcb37'
            '78260b6d62c7f05a38e940b41c5d07f7e9d8f418a6e5fa64ba27d5237a936944')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare() {
  cd ${_realname}-${pkgver}

  # https://github.com/AcademySoftwareFoundation/OpenColorIO/issues/2136
  # https://github.com/AcademySoftwareFoundation/OpenColorIO/issues/2137
  apply_patch_with_msg \
    0003-fix-python-sitearch.patch \
    0005-fix-ifstream-arg.patch \
    0006-fix-neon-build.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
       ${extra_config} \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      -DOCIO_BUILD_TESTS=OFF \
      -DOCIO_BUILD_GPU_TESTS=OFF \
      -DPython_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE "${pkgdir}${MINGW_PREFIX}"/share/licenses/${_realname}/LICENSE

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/OpenColorIO/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i "${_f}"
  done
}
